"""Install method.

$Id: Install.py 55153 2007-12-09 12:42:44Z dbaty $
"""

from StringIO import StringIO

from Products.CMFCore.utils import getToolByName

from Products.CMFNotification.config import GLOBALS
from Products.CMFNotification.config import PROJECT_NAME
from Products.CMFNotification.permissions import SUBSCRIBE_PERMISSION
from Products.CMFNotification.NotificationTool import ID
from Products.CMFNotification.NotificationTool import NotificationTool

from Products.Archetypes.Extensions.utils import install_subskin


def install(self):
    """Install CMFNotification.

    Most of the job is done by a Generic Setup profile.
    """
    out = StringIO()

    ## FIXME: could not this be done by GenericSetup?
    install_subskin(self, out, GLOBALS)

    ## FIXME: it seems like GenericSetup cannot define a new
    ## permission. It can only set allowed roles for an existing
    ## permission. So we have first to register the permission like
    ## this.
    from Products.CMFCore.permissions import setDefaultRoles
    setDefaultRoles(SUBSCRIBE_PERMISSION, ('Manager', ))

    ## Import GenericSetup default profile
    setup_tool = getToolByName(self, 'portal_setup')
    setup_tool.runAllImportStepsFromProfile('profile-Products.CMFNotification:default')

    print >> out, "Successfully installed %s." % PROJECT_NAME
    return out.getvalue()
