#!/bin/sh
# /etc/rc.d/init.d/zeo
# Startup script for Zope with ZEOCluster
#
# chkconfig: 345 80 20
# description: Zope, a web application server
# this works as is for a default universal plone linux install
#
# Source function library.
# config: /opt/plone3/parts/client$/etc/zope.conf

RETVAL=0
clusterpath="/opt/buildout/cyndotintrunk"
prog="cyn.in"
runprog="instance"

start() {
echo -n "Starting $prog: "
output="${clusterpath}/bin/${runprog} start"
# the return status of zopectl is not reliable, we need to parse
# its output via substring match
if $output | grep -q "started"; then
# success
touch /var/lock/$prog
echo "Started cyn.in service."
RETVAL=0
else
# failed
echo "Failed to start cyn.in service."
RETVAL=1
fi
return $RETVAL
}

stop() {

echo -n "Stopping $prog: "
output="${clusterpath}/bin/${runprog} stop"
# the return status of zopectl is not reliable, we need to parse
# its output via substring match
if $output | grep -q "stopped"; then
# success
rm /var/lock/$prog
echo "Stopped."
RETVAL=0
else
# failed
echo "Failed to stop cyn.in. You can kill cyn.in service manually by running ps-A | grep python2.4 and then kill the processids as shown"
RETVAL=1
fi
return $RETVAL
}

restart() {
stop
start
}

case "$1" in
start)
start
;;
stop)
stop
;;
status)
echo -n "${prog}:"
output="${clusterpath}/bin/${runprog} status"
$output
;;
restart)
restart
;;
condrestart)
[ -e /var/lock/$prog ] && restart
;;
*)
echo "Usage: $0 {start|stop|status|restart|condrestart}"
RETVAL=2
esac

exit $RETVAL 
