###############################################################################
#cyn.in is an open source Collaborative Knowledge Management Appliance that 
#enables teams to seamlessly work together on files, documents and content in 
#a secure central environment.
#
#cyn.in v2 an open source appliance is distributed under the GPL v3 license 
#along with commercial support options.
#
#cyn.in is a Cynapse Invention.
#
#Copyright (C) 2008 Cynapse India Pvt. Ltd.
#
#This program is free software: you can redistribute it and/or modify it under
#the terms of the GNU General Public License as published by the Free Software 
#Foundation, either version 3 of the License, or any later version and observe 
#the Additional Terms applicable to this program and must display appropriate 
#legal notices. In accordance with Section 7(b) of the GNU General Public 
#License version 3, these Appropriate Legal Notices must retain the display of 
#the "Powered by cyn.in" AND "A Cynapse Invention" logos. You should have 
#received a copy of the detailed Additional Terms License with this program.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of 
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
#Public License for more details.
#
#You should have received a copy of the GNU General Public License along with 
#this program.  If not, see <http://www.gnu.org/licenses/>.
#
#You can contact Cynapse at support@cynapse.com with any problems with cyn.in. 
#For any queries regarding the licensing, please send your mails to 
# legal@cynapse.com
#
#You can also contact Cynapse at:
#802, Building No. 1,
#Dheeraj Sagar, Malad(W)
#Mumbai-400064, India
###############################################################################
from AccessControl import allow_module
from AccessControl import ModuleSecurityInfo
from AccessControl import ClassSecurityInfo
from ubify.coretypes.config import cynin_applications,cynin_applications_type_ignore
from ubify.viewlets.config import plone_site_type_title
from StringIO import StringIO
from ubify.policy.config import MEMBERS_PLACEFUL_WORKFLOW_POLICY, MEMBERS_PLACEFUL_WORKFLOW_POLICY_BELOW ,spacecontentworkflowtypes
from Products.CMFCore.utils import getToolByName
from ubify.policy.config import user_private_space_items,user_public_space_items
from ubify.policy.config import USER_SPACEFOLDER_WORKFLOW_POLICY,USER_PRIVATE_SPACE_POLICY,USER_PUBLIC_SPACE_POLICY,USER_PUBLIC_SPACE_BELOW_POLICY

from zope.event import notify
from zope.lifecycleevent import ObjectCreatedEvent
import transaction

from Products.CMFPlone.utils import _createObjectByType
from AccessControl import Unauthorized

PasteError = "Paste Error"

def initialize(context):
    """Initializer called when used as a Zope 2 product."""
    ModuleSecurityInfo("ubify.cyninv2theme").declarePublic("SetPortrait")
    ModuleSecurityInfo("ubify.cyninv2theme").declarePublic("validatePasteData")
    ModuleSecurityInfo("ubify.cyninv2theme").declarePublic("PasteError")
    
    ModuleSecurityInfo("ubify.cyninv2theme").declarePublic("getsortedblogentries")
    ModuleSecurityInfo("ubify.cyninv2theme").declarePublic("setup_users_my_area")
    
    #ModuleSecurityInfo("ubify.cyninv2theme").declarePublic("setConstrainsOnMyFolder")
    #ModuleSecurityInfo("ubify.cyninv2theme").declarePublic("setupPlacefulWorkflowOnUser")

def SetPortrait(membertool,portrait,member_id):
    membertool._setPortrait(portrait, member_id)
    
def validatePasteData(context,data):
    from OFS.CopySupport import *
    import marshal,zlib,urllib
    from marshal import loads, dumps
    from urllib import quote, unquote
    from zlib import compress, decompress
    from App.Dialogs import MessageDialog
    
    ob,mdatas = loads(decompress(unquote(data)))
    
    strErrorMessage = ""
    ilen = len(mdatas)
    if ilen > 1:
        for ival in range(1,ilen):
            try:
                performCheck(context,mdatas[ival - 1])
            except PasteError, msg:
                strErrorMessage = strErrorMessage + msg + " "            
    elif ilen == 1:
        try:
            performCheck(context,mdatas[ilen - 1])
        except PasteError, msg:
            strErrorMessage = strErrorMessage + msg + " "
    
    if strErrorMessage <> "":
        strErrorMessage = "Cannot paste Folders between different applications.Disallowed to paste item(s)."
        raise PasteError,strErrorMessage
        
def performCheck(context,mdata):
    strURL = "/".join(mdata)
            
    rootObject = context.portal_url.getPortalObject()
    copiedObject = rootObject.restrictedTraverse(strURL)
    if copiedObject.portal_type == 'Folder':
        parentObject = copiedObject.getParentNode()
        try:
            getApplication(copiedObject,context,rootObject)
        except PasteError, msg:
            raise PasteError,msg
        
def getApplication(source,dest,root):
    sourcelist = source.aq_chain
    destlist = dest.aq_chain
    
    sFound = False
    dFound = False
    
    sApplication = None
    dApplication = None
    
    for type in sourcelist:
        try:
            if type.portal_type in cynin_applications:
                sFound = True
                sApplication = type
                if sFound == True:
                    break;
        except AttributeError:
            sApplication = root

    for type in destlist:
        try:            
            if type.portal_type in cynin_applications:
                dFound = True
                dApplication = type
                if dFound == True:
                    break;
        except AttributeError:
            dApplication = root
    
    dtype = getTitle(root,dApplication)
    stype = getTitle(root,sApplication)
        
    if sApplication <> None and dApplication <> None and sApplication.portal_type != dApplication.portal_type:
        msg = "You are not allowed to paste '%s' from type '%s' to '%s'." % (source.title,stype,dtype,)
        raise PasteError,msg
    
def getTitle(portal,application):
    from Products.CMFCore.utils import getToolByName
    typetool= getToolByName(portal, 'portal_types')
    object_typename = application.portal_type
    object_typeobj = typetool[object_typename]
    
    if object_typeobj.title == '' and portal.portal_type.lower() == 'plone site':
        return plone_site_type_title
    else:
        return object_typeobj.title
    
def setConstrainsOnMyFolder(context):
    allowed_applications = (
        'Gallery',
        'Blog',
        'Wiki',
        'LinkDirectory',
        'FileRepository',
        'Calendar',
        'Folder',
        'GenericContainer',
        'Topic'
    )
    
    context.setConstrainTypesMode(1)
    context.setImmediatelyAddableTypes(allowed_applications)
    context.setLocallyAllowedTypes(allowed_applications)
    context.reindexObject()
    
def setupPlacefulWorkflowOnUser(context):
    out = StringIO()
    
    if context <> None:
        placeful_workflow = getToolByName(context, 'portal_placeful_workflow')
        try:
            config = placeful_workflow.getWorkflowPolicyConfig(context)
        except:
            context.manage_addProduct['CMFPlacefulWorkflow'].manage_addWorkflowPolicyConfig()
            config = placeful_workflow.getWorkflowPolicyConfig(context)
            
        if config is None:
            context.manage_addProduct['CMFPlacefulWorkflow'].manage_addWorkflowPolicyConfig()
            config = placeful_workflow.getWorkflowPolicyConfig(context)
            config.setPolicyIn(policy=MEMBERS_PLACEFUL_WORKFLOW_POLICY)
            config.setPolicyBelow(policy=MEMBERS_PLACEFUL_WORKFLOW_POLICY_BELOW)
            print >> out, "Configured placeful workflow on %s" % (context,)
            return out.getvalue()
        else:
            config.setPolicyIn(policy=MEMBERS_PLACEFUL_WORKFLOW_POLICY)
            config.setPolicyBelow(policy=MEMBERS_PLACEFUL_WORKFLOW_POLICY_BELOW)
            print >> out, "Configured placeful workflow on %s" % (context,)
            return out.getvalue()

def getsortedblogentries(context):
    results = []
    path = "/".join(context.getPhysicalPath())
    try:
        query = {'path': {'query':path,'depth':1},'sort_on':'created','sort_order':'descending'}
        pcatalog = context.portal_catalog
        results = pcatalog.searchResults(query)
    except (RuntimeError,TypeError,NameError):
        pass
    return results

def getOrCreateType(portal, atobj, newid, newtypeid):
    """
    Gets the object specified by newid if it already exists under
    atobj or creates it there with the id given in newtypeid
    """
    #import pdb;pdb.set_trace()
    try:
        newobj = getattr(atobj,newid) #get it if it already exists
    except AttributeError:  #newobj doesn't already exist
        try:            
            _ = atobj.invokeFactory(id=newid,type_name=newtypeid)            
        except ValueError:
            _createObjectByType(newtypeid, atobj, newid)
        except Unauthorized:
            _createObjectByType(newtypeid, atobj, newid)
        newobj = getattr(atobj,newid)
        notify(ObjectCreatedEvent(newobj))
    return newobj

def updateWorkflowSecurity(portal):
    out = StringIO()
    pw = getattr(portal,'portal_workflow')    
    count = 0
    if pw <> None:
        count = pw.updateRoleMappings()
        print >> out, "Updated workflow role mappings for %s objects" % (count,)
    return out.getvalue()

def set_placeful_workflow_policy(target,policyin,policybelow):
    placeful_workflow = getToolByName(target, 'portal_placeful_workflow')
    try:
        config = placeful_workflow.getWorkflowPolicyConfig(target)
    except AttributeError:
        target.manage_addProduct['CMFPlacefulWorkflow'].manage_addWorkflowPolicyConfig()
        config = placeful_workflow.getWorkflowPolicyConfig(target)    
        
    if config is None:
        target.manage_addProduct['CMFPlacefulWorkflow'].manage_addWorkflowPolicyConfig()
        config = placeful_workflow.getWorkflowPolicyConfig(target)
    
    if policyin <> None:
        config.setPolicyIn(policy=policyin)
    if policybelow <> None:
        config.setPolicyBelow(policy=policybelow)
    
    target.reindexObject()

def setup_users_privatespace(context):
    try:
        privatespace = getattr(context,'private')
    except AttributeError:
        privatespace = getOrCreateType(context,context,'private','Space')
    privatespace.title = "Private"
    privatespace.reindexObject()    
    
    set_placeful_workflow_policy(privatespace,USER_PRIVATE_SPACE_POLICY,USER_PRIVATE_SPACE_POLICY)
    
    if privatespace <> None:
        #create applications
        for item in user_private_space_items:
            id = item["id"]
            title = item["title"]
            type = item["type"]
            try:
                newobj = getattr(privatespace,id)
            except AttributeError:
                newobj = getOrCreateType(context,privatespace,id,type)
            
            newobj.title = title
            if newobj.portal_type.lower() == 'gallery' and newobj.getLayout() != "atct_album_view":
                newobj.setLayout("atct_album_view")
            newobj.reindexObject()

def setup_users_publicspace(context):
    try:
        publicspace = getattr(context,'public')
    except AttributeError:
        publicspace = getOrCreateType(context,context,'public','Space')
    publicspace.title = "Public"
    publicspace.reindexObject()
    
    set_placeful_workflow_policy(publicspace,USER_PUBLIC_SPACE_POLICY,USER_PUBLIC_SPACE_BELOW_POLICY)
    
    if publicspace <> None:
        #create applications
        for item in user_public_space_items:
            id = item["id"]
            title = item["title"]
            type = item["type"]
            try:
                newobj = getattr(publicspace,id)
            except AttributeError:
                newobj = getOrCreateType(context,publicspace,id,type)
            
            newobj.title = title
            if newobj.portal_type.lower() == 'gallery' and newobj.getLayout() != "atct_album_view":
                newobj.setLayout("atct_album_view")
            
            newobj.reindexObject()

def setup_users_my_area(context):
    setup_users_privatespace(context)
    setup_users_publicspace(context)   
    set_placeful_workflow_policy(context,USER_SPACEFOLDER_WORKFLOW_POLICY,None)
    
    portal = context.portal_url.getPortalObject()
    updateWorkflowSecurity(portal)

def getCurrentUser(object):
    from AccessControl.SecurityManagement import newSecurityManager
    from AccessControl import getSecurityManager
    
    currentOwner = object.getOwner()
    newSecurityManager(None,currentOwner)
    
def getAdminUser(portal):
    from AccessControl.SecurityManagement import noSecurityManager
    from AccessControl.SecurityManagement import newSecurityManager
    adminUser = portal.getParentNode().acl_users.getUserById('admin')
    newSecurityManager(None,adminUser)

    
def migrateuserareas(object):
    
    portal = object.portal_url.getPortalObject()    
    
    #make owner of the object as user in context for creating inner objects
    getCurrentUser(object)
    
    from AccessControl import getSecurityManager
    currentuserid = getSecurityManager().getUser().getId()
    if currentuserid is None:
        getAdminUser(portal)
        currentuserid = getSecurityManager().getUser().getId()
        
    if currentuserid <> None and object <> None:        
        ids = object.objectIds()
        try:
            myimporteditems = getattr(object,'myimporteditems')
        except AttributeError:
            myimporteditems = getOrCreateType(object,object,'myimporteditems','GenericContainer')
            
        myimporteditems.title = "My Imported Items"
        myimporteditems.reindexObject()
        
        for jid in ids:
            try:
                cb = object.manage_copyObjects(ids = jid)
                myimporteditems.manage_pasteObjects(cb)
                transaction.savepoint()
            except Unauthorized:
                getAdminUser(portal)
                cb = object.manage_copyObjects(ids = jid)
                myimporteditems.manage_pasteObjects(cb)
                transaction.savepoint()
                getCurrentUser(object)
                
        #cb = object.manage_copyObjects(ids= ids)
        #myimporteditems.manage_pasteObjects(cb)
        #transaction.savepoint()
        
        object.manage_delObjects(ids=ids)
        transaction.savepoint()
        
        setup_users_privatespace(object)
        setup_users_publicspace(object)
        
        publicspace = getattr(object,'public')
        
        cb1 = object.manage_cutObjects(ids=('myimporteditems',))
        #import pdb;pdb.set_trace()
        publicspace.manage_pasteObjects(cb1)
        transaction.savepoint()
        
        set_placeful_workflow_policy(object,USER_SPACEFOLDER_WORKFLOW_POLICY,None)        
    
    #make admin as user in context for creating inner objects
    getAdminUser(portal)
    