###############################################################################
#cyn.in is an open source Collaborative Knowledge Management Appliance that 
#enables teams to seamlessly work together on files, documents and content in 
#a secure central environment.
#
#cyn.in v2 an open source appliance is distributed under the GPL v3 license 
#along with commercial support options.
#
#cyn.in is a Cynapse Invention.
#
#Copyright (C) 2008 Cynapse India Pvt. Ltd.
#
#This program is free software: you can redistribute it and/or modify it under
#the terms of the GNU General Public License as published by the Free Software 
#Foundation, either version 3 of the License, or any later version and observe 
#the Additional Terms applicable to this program and must display appropriate 
#legal notices. In accordance with Section 7(b) of the GNU General Public 
#License version 3, these Appropriate Legal Notices must retain the display of 
#the "Powered by cyn.in" AND "A Cynapse Invention" logos. You should have 
#received a copy of the detailed Additional Terms License with this program.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of 
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
#Public License for more details.
#
#You should have received a copy of the GNU General Public License along with 
#this program.  If not, see <http://www.gnu.org/licenses/>.
#
#You can contact Cynapse at support@cynapse.com with any problems with cyn.in. 
#For any queries regarding the licensing, please send your mails to 
# legal@cynapse.com
#
#You can also contact Cynapse at:
#802, Building No. 1,
#Dheeraj Sagar, Malad(W)
#Mumbai-400064, India
###############################################################################
import transaction
from StringIO import StringIO
from Products.CMFCore.utils import getToolByName
from ubify.policy.config import PRODUCT_DEPENDENCIES,REINSTALL_PRODUCT_DEPENDENCIES

PRODUCT_DEPENDENCIES = PRODUCT_DEPENDENCIES

EXTENSION_PROFILES = ('ubify.policy:default',
)

def install(self,
 reinstall=False):
    """Install a set of products (which themselves may either use Install.py
    or GenericSetup extension profiles for their configuration) and then
    install a set of extension profiles.
    
    One of the extension profiles we install is that of this product. This
    works because an Install.py installation script (such as this one) takes
    precedence over extension profiles for the same product in 
    portal_quickinstaller. 
    
    We do this because it is not possible to install other products during
    the execution of an extension profile (i.e. we cannot do this during
    the importVarious step for this profile).
    """
    
    #import pdb; pdb.set_trace()
    
    portal_quickinstaller = getToolByName(self, 'portal_quickinstaller')
    portal_setup = getToolByName(self, 'portal_setup')    
    
    if reinstall:
	for product in PRODUCT_DEPENDENCIES:
            if not portal_quickinstaller.isProductInstalled(product):
                portal_quickinstaller.installProduct(product)
                transaction.savepoint()
        for product in REINSTALL_PRODUCT_DEPENDENCIES:
            if portal_quickinstaller.isProductInstalled(product):
                portal_quickinstaller.reinstallProducts([product])
                transaction.savepoint()
            elif not portal_quickinstaller.isProductInstalled(product):
                portal_quickinstaller.installProduct(product)
                transaction.savepoint()
    else:
        for product in PRODUCT_DEPENDENCIES:
            if not portal_quickinstaller.isProductInstalled(product):
                portal_quickinstaller.installProduct(product)
                transaction.savepoint()
        
    for extension_id in EXTENSION_PROFILES:
        portal_setup.runAllImportStepsFromProfile('profile-%s' % extension_id, purge_old=False)
        product_name = extension_id.split(':')[0]
        portal_quickinstaller.notifyInstalled(product_name)
        transaction.savepoint()        
    
    #call one time installation here if reinstall is false
    out = StringIO()
    portal = self
    
    from Products.GenericSetup.context import Logger,SetupEnviron    
    obj = SetupEnviron()
    logger = obj.getLogger("ubify.policy")
    
    if reinstall:
        pass
    else:
        from ubify.policy.migration.onetimeinstall import addDefaultDashboardViews,setup_sitehome_collection_portlets,addDefaultSmartViews
        logger.info(addDefaultSmartViews(portal))
        logger.info(addDefaultDashboardViews(portal))
        setup_sitehome_collection_portlets(portal,out)
        logger.info(out.getvalue())        
    from ubify.policy.migration.onetimeinstall import updateWorkflowSecurity
    logger.info(updateWorkflowSecurity(portal))
