###############################################################################
#cyn.in is an open source Collaborative Knowledge Management Appliance that 
#enables teams to seamlessly work together on files, documents and content in 
#a secure central environment.
#
#cyn.in v2 an open source appliance is distributed under the GPL v3 license 
#along with commercial support options.
#
#cyn.in is a Cynapse Invention.
#
#Copyright (C) 2008 Cynapse India Pvt. Ltd.
#
#This program is free software: you can redistribute it and/or modify it under
#the terms of the GNU General Public License as published by the Free Software 
#Foundation, either version 3 of the License, or any later version and observe 
#the Additional Terms applicable to this program and must display appropriate 
#legal notices. In accordance with Section 7(b) of the GNU General Public 
#License version 3, these Appropriate Legal Notices must retain the display of 
#the "Powered by cyn.in" AND "A Cynapse Invention" logos. You should have 
#received a copy of the detailed Additional Terms License with this program.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of 
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
#Public License for more details.
#
#You should have received a copy of the GNU General Public License along with 
#this program.  If not, see <http://www.gnu.org/licenses/>.
#
#You can contact Cynapse at support@cynapse.com with any problems with cyn.in. 
#For any queries regarding the licensing, please send your mails to 
# legal@cynapse.com
#
#You can also contact Cynapse at:
#802, Building No. 1,
#Dheeraj Sagar, Malad(W)
#Mumbai-400064, India
###############################################################################
from Products.CMFCore.utils import getToolByName
from StringIO import StringIO
from Products.CMFEditions.setuphandlers import DEFAULT_POLICIES
from Products.Collage.interfaces import IDynamicViewManager
from zope.component import getUtility
from zope.component import getMultiAdapter
from plone.portlets.interfaces import IPortletAssignmentMapping
from plone.portlets.interfaces import IPortletManager
from plone.app.controlpanel.markup import MarkupControlPanelAdapter
from ubify.policy.config import *
from Products.CMFCore.ActionInformation import Action
from Products.CMFCore.ActionInformation import ActionCategory
from Products.CMFCore.Expression import Expression
from Products.CMFNotification.NotificationTool import ID as NTOOL_ID
from Acquisition import aq_inner, aq_parent, aq_base

from Products.CMFPlone.utils import _createObjectByType
from AccessControl import Unauthorized
from ubify.policy.migration.migration import *

from ubify.spaces.config import PLACEFUL_WORKFLOW_POLICY, SPACE_PLACEFUL_WORKFLOW_POLICY, REVIEW_PLACEFUL_WORKFLOW_POLICY


import transaction

from zope.event import notify
from zope.lifecycleevent import ObjectCreatedEvent
from zope.component import createObject
from zope.schema.interfaces import IVocabularyFactory
from zope.component import getUtility,getMultiAdapter,getSiteManager

def getOrCreateType(portal, atobj, newid, newtypeid):
    """
    Gets the object specified by newid if it already exists under
    atobj or creates it there with the id given in newtypeid
    """
    #import pdb;pdb.set_trace()
    try:
        newobj = getattr(atobj,newid) #get it if it already exists
    except AttributeError:  #newobj doesn't already exist
        try:            
            _ = atobj.invokeFactory(id=newid,type_name=newtypeid)            
        except ValueError:
            _createObjectByType(newtypeid, atobj, newid)
        except Unauthorized:
            _createObjectByType(newtypeid, atobj, newid)
        newobj = getattr(atobj,newid)
        notify(ObjectCreatedEvent(newobj))
    return newobj

def getViews(portal):
    return getOrCreateType(portal,portal,"views","SmartviewFolder")

def updateWorkflowSecurity(portal):
    out = StringIO()
    pw = getattr(portal,'portal_workflow')    
    count = 0
    if pw <> None:
        count = pw.updateRoleMappings()
        print >> out, "Updated workflow role mappings for %s objects" % (count,)
    return out.getvalue()

def get_assignments_for_sitehome_collectionportlets(portal,views,out):
    assignments = []
    from plone.portlet.collection import collection
    
    for item in default_sitehome_smartviews:
        try:
            objsmartview = getattr(views,item["id"])
            target_coll = "/".join(objsmartview.getPhysicalPath())
            assignments.append(collection.Assignment(item["displaytitle"],target_coll,item["limit"],True,False))
        except:
            print >> out, "Unable to assign collection portlet for smartview : %s" % (item["id"],)
    
    return assignments
        
def setup_sitehome_collection_portlets(portal, out):
    
    from plone.portlets.interfaces import IPortletManager
    from plone.portlets.interfaces import ILocalPortletAssignmentManager
    from plone.portlets.constants import CONTEXT_CATEGORY
    from zope.app.container.interfaces import INameChooser
    from plone.portlets.interfaces import IPortletAssignmentMapping
    from zope.component.interfaces import ComponentLookupError
    
    from plone.portlets.interfaces import IPortletManager
    from plone.portlets.manager import PortletManager
    from zope.interface import alsoProvides
    
    from ubify.viewlets.browser.interfaces import IHomeContent
    
    try:
        objviews = getattr(portal,'views')
        assignments = get_assignments_for_sitehome_collectionportlets(portal,objviews,out)
        sm = getSiteManager(portal)
        name = 'ubify.homecontentportletsmanager'
        try:
            portletManager = getUtility(IPortletManager, name=name)
        except ComponentLookupError:
            objportletManager = PortletManager()
            alsoProvides(objportletManager,IHomeContent)
                
            sm.registerUtility(component=objportletManager,
                               provided=IPortletManager,
                               name = name)        
            portletManager = getUtility(IPortletManager, name=name)
            
        assignable = getMultiAdapter((portal, portletManager,), ILocalPortletAssignmentManager)
        manager = getMultiAdapter((portal, portletManager), IPortletAssignmentMapping)
        
        if assignments:        
            if portletManager is not None:            
                chooser = INameChooser(manager)            
                for assignment in assignments:
                    if manager.has_key(assignment.id) == 0:
                        manager[chooser.chooseName(None, assignment)] = assignment
                        print >> out, "Assigning collection portlet manager for %s" % (assignment.id,)        
    except AttributeError:
        print >> out, "Unable to set up site home collection portlets."
        
def changeHomePortletsTitles(portal,out):
    
    from plone.portlets.interfaces import IPortletManager
    from plone.portlets.interfaces import ILocalPortletAssignmentManager
    from plone.portlets.constants import CONTEXT_CATEGORY
    from zope.app.container.interfaces import INameChooser
    from plone.portlets.interfaces import IPortletAssignmentMapping
    from zope.component.interfaces import ComponentLookupError
    
    from plone.portlets.interfaces import IPortletManager
    from plone.portlets.manager import PortletManager
    from zope.interface import alsoProvides
    
    from ubify.viewlets.browser.interfaces import IHomeContent
    
    try:
        objviews = getattr(portal,'views')
        assignments = get_assignments_for_sitehome_collectionportlets(portal,objviews,out)
        sm = getSiteManager(portal)
        name = 'ubify.homecontentportletsmanager'
        try:
            portletManager = getUtility(IPortletManager, name=name)
        except ComponentLookupError:
            objportletManager = PortletManager()
            alsoProvides(objportletManager,IHomeContent)
                
            sm.registerUtility(component=objportletManager,
                               provided=IPortletManager,
                               name = name)        
            portletManager = getUtility(IPortletManager, name=name)
            
        assignable = getMultiAdapter((portal, portletManager,), ILocalPortletAssignmentManager)
        manager = getMultiAdapter((portal, portletManager), IPortletAssignmentMapping)
        
        mgkeys = manager.keys()
        for k in mgkeys:
            del manager[k]
            
        if assignments:        
            if portletManager is not None:            
                chooser = INameChooser(manager)            
                for assignment in assignments:
                    if manager.has_key(assignment.id) == 0:
                        manager[chooser.chooseName(None, assignment)] = assignment
                        print >> out, "Assigning collection portlet manager for %s" % (assignment.id,)  
    except AttributeError:
        print >> out, "Unable to set up site home collection portlets."
        
def addDefaultDashboardViews(portal):
    out = StringIO()
    objviews = getViews(portal)
    
    for eachview in default_sitehome_smartviews:
        try:
            sattr = getattr(objviews,eachview["id"])
        except:
            sattr = getOrCreateType(portal,objviews,eachview["id"],"Topic")
            sattr.title = eachview["title"]
            sattr.description = eachview["description"]
            sattr.limitNumber = eachview["limitnumber"]
            sattr.itemCount = eachview["itemcount"]
            
            try:
                critid = getattr(sattr,'crit__Type_ATPortalTypeCriterion')
            except AttributeError:
                critid = sattr.addCriterion(field='Type',criterion_type='ATPortalTypeCriterion')
            if critid <> None:
                typecrit = critid
                typecrit.value = eachview["type"]
            else:
                print >> out, "Could not create type criteria, critid = %s" % (critid,)
                
            try:
                critid = getattr(sattr,'crit__modified_ATSortCriterion')
            except AttributeError:
                critid = sattr.addCriterion(field='modified',criterion_type='ATSortCriterion')
            if critid <> None:
                sortcrit = critid
                sortcrit.reversed = True
            else:
                print >> out, "Could not create sort criteria, critid = %s" % (critid,)
            
            if sattr.id == "allimages" and sattr.getLayout() != "atct_album_view":                    
                sattr.setLayout("atct_album_view")
            if sattr.id == "allblogentries" and sattr.getLayout() != "blog_view":
                sattr.setLayout("blog_view")
            
            print >> out , "Added smart view with id : %s" % (eachview["id"],)
            sattr.reindexObject()
    return out.getvalue()

def addDefaultSmartViews(portal):
    out = StringIO()
    try:
        objView = getattr(portal,"views")
        if objView <> None:
            for q in defaultsmartviews:
                obj = getOrCreateType(portal,objView,q["id"],"SmartView")
                obj.title = q["title"]
                obj.description = q["description"]
                obj.query = str(q["query"])
                obj.reindexObject()
                print >> out,"Created smartview for %s" % (q["title"],)
    except:
        pass
    return out.getvalue()
