###############################################################################
#cyn.in is an open source Collaborative Knowledge Management Appliance that 
#enables teams to seamlessly work together on files, documents and content in 
#a secure central environment.
#
#cyn.in v2 an open source appliance is distributed under the GPL v3 license 
#along with commercial support options.
#
#cyn.in is a Cynapse Invention.
#
#Copyright (C) 2008 Cynapse India Pvt. Ltd.
#
#This program is free software: you can redistribute it and/or modify it under
#the terms of the GNU General Public License as published by the Free Software 
#Foundation, either version 3 of the License, or any later version and observe 
#the Additional Terms applicable to this program and must display appropriate 
#legal notices. In accordance with Section 7(b) of the GNU General Public 
#License version 3, these Appropriate Legal Notices must retain the display of 
#the "Powered by cyn.in" AND "A Cynapse Invention" logos. You should have 
#received a copy of the detailed Additional Terms License with this program.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of 
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
#Public License for more details.
#
#You should have received a copy of the GNU General Public License along with 
#this program.  If not, see <http://www.gnu.org/licenses/>.
#
#You can contact Cynapse at support@cynapse.com with any problems with cyn.in. 
#For any queries regarding the licensing, please send your mails to 
# legal@cynapse.com
#
#You can also contact Cynapse at:
#802, Building No. 1,
#Dheeraj Sagar, Malad(W)
#Mumbai-400064, India
###############################################################################
from Products.CMFCore.utils import getToolByName
from StringIO import StringIO
from Products.CMFEditions.setuphandlers import DEFAULT_POLICIES
from Products.Collage.interfaces import IDynamicViewManager
from zope.component import getUtility
from zope.component import getMultiAdapter
from plone.portlets.interfaces import IPortletAssignmentMapping
from plone.portlets.interfaces import IPortletManager
from plone.app.controlpanel.markup import MarkupControlPanelAdapter
from config import *
from Products.CMFCore.ActionInformation import Action
from Products.CMFCore.ActionInformation import ActionCategory
from Products.CMFCore.Expression import Expression
from Products.CMFNotification.NotificationTool import ID as NTOOL_ID
from Acquisition import aq_inner, aq_parent, aq_base

from Products.CMFPlone.utils import _createObjectByType
from AccessControl import Unauthorized
from ubify.policy.migration.migration import *
from ubify.policy.migration.onetimeinstall import *

from ubify.spaces.config import PLACEFUL_WORKFLOW_POLICY, SPACE_PLACEFUL_WORKFLOW_POLICY, REVIEW_PLACEFUL_WORKFLOW_POLICY


import transaction

from zope.event import notify
from zope.lifecycleevent import ObjectCreatedEvent
from zope.component import createObject
from zope.schema.interfaces import IVocabularyFactory
from zope.component import getUtility



def disableGlobalAdds(portal):
    out = StringIO()
    portal_types = getToolByName(portal, 'portal_types')
    fti = getattr(portal_types, 'News Item')
    fti.global_allow = False
    
    fti = getattr(portal_types, 'SpacesFolder')
    fti.global_allow = False
    fti = getattr(portal_types,'SmartviewFolder')
    fti.global_allow = False
    print >> out, "Disabled News Item"
    print >> out, "Disabled Collage"
    print >> out, "Disabled SpacesFolder"
    print >> out, "Disabled SmartviewFolder"
    return out.getvalue()
    
def renameScrawl(portal_types):
    blog_fti = getattr(portal_types, 'Blog Entry')
    blog_fti.description = "A blog post that will appear in blog views"
    blog_fti.content_icon = 'newsitem_icon.png'
    blog_fti.global_allow = True

def renameBorg(portal_types):
    borg_fti = getattr(portal_types, 'b-org Project')
    borg_fti.description = "Space. The Final Frontier.  ;-)"
    borg_fti.title = "Space"
#    borg_fti.content_icon = ''
    borg_fti.global_allow = True


def removeNewsItemViewFromBlogEntry(portal_types):
    blogentry = getattr(portal_types,'Blog Entry')    
    view = 'blogentry_view'    
    blogentry._updateProperty('view_methods', (view,))

def configureContentTypes(portal):
    out = StringIO()
    portal_types = getToolByName(portal, 'portal_types')
    renameScrawl(portal_types)
    print >> out, "Renamed Scrawl"
    #renameBorg(portal_types)
    print >> out, "Renamed b-org"
    removeNewsItemViewFromBlogEntry(portal_types)
    print >> out, "Removed News Item View from Blog Entry"
    return out.getvalue()

def setup_folders(portal):
    out = StringIO()
    try:
        portal.manage_delObjects('news')
        print >> out, "Deleted %s folder" % 'news'
    except AttributeError:
        print >> out, "No %s folder detected. Hmm... strange. Continuing..." % 'news'

    try:
        portal.manage_delObjects('events')
        print >> out, "Deleted Events folder"
    except AttributeError:
        print >> out, "No %s folder detected. Hmm... strange. Continuing..." % 'events'

    try:  #delete front-page
        portal.manage_delObjects('front-page')
        print >> out, "Deleted Default front page"
    except AttributeError:
        print >> out, "No %s item detected. Hmm... strange. Continuing..." % 'front-page'
    
    portalmembership = getToolByName(portal, 'portal_membership')
    portalmembership.setMemberAreaType('SpacesFolder')
    if portalmembership.getMemberareaCreationFlag() == 0:
        _ = portalmembership.setMemberareaCreationFlag()  #Set Member Area Creation On, and discard return value
    
    try:
        portal_actions = getToolByName(portal,'portal_actions')
        user_actions = getattr(portal_actions,'user')
        my_stuff = getattr(user_actions,'mystuff')
        if my_stuff <> None:
            my_stuff._updateProperty('title',user_my_folder_name)
            my_stuff.visible = False
            print >> out, "Renamed My Folder to %s" % (user_my_folder_name,)
    except:
        print >> out, "unable to rename My Folder"
    
    #import pdb; pdb.set_trace()

    return out.getvalue()

def setVersionedTypes(portal):
    out = StringIO()
    portal_repository = getToolByName(portal, 'portal_repository')
    versionable_types = list(portal_repository.
    getVersionableContentTypes())
    for type_id in ('Blog Entry', 'Image', 'File', 'Document',):
        if type_id not in versionable_types:
            versionable_types.append(type_id)
            # Add default versioning policies to the versioned type
            for policy_id in DEFAULT_POLICIES:
                portal_repository.addPolicyForContentType(type_id,policy_id)
    portal_repository.setVersionableContentTypes(versionable_types)
    print >> out, "Set up versionable types."
    return out.getvalue()

def setup_recentpictures(portal):
    out = StringIO()
    try:
        coll = getattr(portal,'maindashboard')
    except AttributeError:
        _ = portal.invokeFactory(id='maindashboard',type_name='Collage')
        coll = getattr(portal,'maindashboard')
        
    try:
        row = getattr(coll,'row2')
    except AttributeError:
        _ = coll.invokeFactory(id='row2',type_name='CollageRow')
        row = getattr(coll,'row2')
        
    try:
        col = getattr(row,'row2column1')
    except AttributeError:
        _ = row.invokeFactory(id='row2column1',type_name='CollageColumn')
        col = getattr(row,'row2column1')

    try:        
        pics = getattr(col,'recentpictures')
    except AttributeError:
        _ = col.invokeFactory(id='recentpictures',type_name='Topic')
        pics = getattr(col,'recentpictures')
    pics.title = 'Recent Pictures'
    pics.description = 'Recent Pictures from across this Ubify site'
    pics.limitNumber = True;
    pics.itemCount = 6;
    
    try:
        critid = getattr(pics,'crit__Type_ATPortalTypeCriterion')
    except AttributeError:
        critid = pics.addCriterion(field='Type',criterion_type='ATPortalTypeCriterion')
    if critid <> None:
        typecrit = critid
        typecrit.value = (u'Image',)
    else:
        print >> out, "Could not create type criteria, critid = %s" % (critid,)
        #import pdb; pdb.set_trace()
    try:
        critid = getattr(pics,'crit__modified_ATSortCriterion')
    except AttributeError:
        critid = pics.addCriterion(field='modified',criterion_type='ATSortCriterion')
    if critid <> None:
        sortcrit = critid
        sortcrit.reversed = True
    else:
        print >> out, "Could not create sort criteria, critid = %s" % (critid,)
        #import pdb; pdb.set_trace()
    print >> out, "Added Recent Pictures SmartFolder to Main Dashboard Collage."
    manager = IDynamicViewManager(pics)
    manager.setLayout("album")
    print >> out, "Set the Recent Pictures SmartFolder to Album View."
    return out.getvalue()

def setup_recentblogs(portal):
    out = StringIO()
    try:
        coll = getattr(portal,'maindashboard')
    except AttributeError:
        _ = portal.invokeFactory(id='maindashboard',type_name='Collage')
        coll = getattr(portal,'maindashboard')
        
    try:
        row = getattr(coll,'row1')
    except AttributeError:
        _ = coll.invokeFactory(id='row1',type_name='CollageRow')
        row = getattr(coll,'row1')
        
    try:
        col = getattr(row,'row1column1')
    except AttributeError:
        _ = row.invokeFactory(id='row1column1',type_name='CollageColumn')
        col = getattr(row,'row1column1')

    try:        
        blogs = getattr(col,'recentblogs')
    except AttributeError:
        _ = col.invokeFactory(id='recentblogs',type_name='Topic')
        blogs = getattr(col,'recentblogs')

    blogs.title = 'Recent Blogs'
    blogs.description = 'Recent Blog posts from across this Ubify site'
    blogs.limitNumber = True;
    blogs.itemCount = 5;

    try:
        critid = getattr(blogs,'crit__Type_ATPortalTypeCriterion')
    except AttributeError:
        critid = blogs.addCriterion(field='Type',criterion_type='ATPortalTypeCriterion')
    if critid <> None:
        typecrit = critid
        typecrit.value = (u'Blog Entry',)
    else:
        print >> out, "Could not create type criteria, critid = %s" % (critid,)
        #import pdb; pdb.set_trace()

    try:
        critid = getattr(blogs,'crit__modified_ATSortCriterion')
    except AttributeError:
        critid = blogs.addCriterion(field='modified',criterion_type='ATSortCriterion')
    if critid <> None:
        sortcrit = critid
        sortcrit.reversed = True
    else:
        print >> out, "Could not create sort criteria, critid = %s" % (critid,)
        #import pdb; pdb.set_trace()

    print >> out, "Added Recent Blogs SmartFolder to Main Dashboard Collage."
    manager = IDynamicViewManager(blogs)
    manager.setLayout("portlet")
    print >> out, "Set the Recent Blogs SmartFolder to Portlet View."
    return out.getvalue()
    
def setup_recentupdates(portal):
    out = StringIO()
    try:
        coll = getattr(portal,'maindashboard')
    except AttributeError:
        _ = portal.invokeFactory(id='maindashboard',type_name='Collage')
        coll = getattr(portal,'maindashboard')
        
    try:
        row = getattr(coll,'row2')
    except AttributeError:
        _ = coll.invokeFactory(id='row2',type_name='CollageRow')
        row = getattr(coll,'row2')
        
    try:
        col = getattr(row,'row2column2')
    except AttributeError:
        _ = row.invokeFactory(id='row2column2',type_name='CollageColumn')
        col = getattr(row,'row2column2')

    try:        
        updates = getattr(col,'recentupdates')
    except AttributeError:
        _ = col.invokeFactory(id='recentupdates',type_name='Topic')
        updates = getattr(col,'recentupdates')

    updates.title = 'Recent updates'
    updates.description = 'Recent updates from across this Ubify site'
    updates.limitNumber = True;
    updates.itemCount = 10;
    
    try:
        critid = getattr(updates,'crit__Type_ATPortalTypeCriterion')
    except AttributeError:
        critid = updates.addCriterion(field='Type',criterion_type='ATPortalTypeCriterion')
    if critid <> None:
        typecrit = critid
        typecrit.value = (u'File',u'Link',u'Document',)
    else:
        print >> out, "Could not create type criteria, critid = %s" % (critid,)
        #import pdb; pdb.set_trace()

    try:
        critid = getattr(updates,'crit__modified_ATSortCriterion')
    except AttributeError:
        critid = updates.addCriterion(field='modified',criterion_type='ATSortCriterion')
    if critid <> None:
        sortcrit = critid
        sortcrit.reversed = True
    else:
        print >> out, "Could not create sort criteria, critid = %s" % (critid,)
        #import pdb; pdb.set_trace()
    print >> out, "Added Recent updates SmartFolder to Main Dashboard Collage."
    manager = IDynamicViewManager(updates)
    manager.setLayout("portlet")
    print >> out, "Set the Recent updates SmartFolder to Portlet View."
    return out.getvalue()
    
def setup_defaultview(portal):
    out = StringIO()
    portal.default_page = 'maindashboard'
    print >> out, "Set default page to Main Dashboard Collage."
    return out.getvalue()

def setup_myreviewlist(portal):
    out = StringIO()    
    return out.getvalue()

def setup_myrecentitems(portal):
    out = StringIO()
    try:
        coll = getattr(portal,'maindashboard')
    except AttributeError:
        _ = portal.invokeFactory(id='maindashboard', type_name='Collage')
        coll = getattr(portal,'maindashboard')
        
    try:
        row = getattr(coll,'row3')
    except AttributeError:
        _ = coll.invokeFactory(id='row3', type_name='CollageRow')
        row = getattr(coll,'row3')
        
    try:
        col = getattr(row,'row3column2')
    except AttributeError:
        _ = row.invokeFactory(id='row3column2', type_name='CollageColumn')
        col = getattr(row,'row3column2')
    
    try:
        myitems = getattr(col,'myrecentitems')
    except AttributeError:
        _ = col.invokeFactory(id='myrecentitems', type_name='Topic')
        myitems = getattr(col,'myrecentitems')
        
    myitems.title = 'My Recent Items'
    myitems.description = 'My items from across this Ubify site'
    myitems.limitNumber = True
    myitems.itemCount = 10
    
    try:
        critid = getattr(myitems,'crit__Creator_ATCurrentAuthorCriterion')
    except AttributeError:
        critid = myitems.addCriterion(field='Creator',criterion_type='ATCurrentAuthorCriterion')
    if critid <> None:
        creatorcrit = critid
    else:
        print >> out, "Could not create Creator criteria, critid = %s" % (critid,)
        
    try:
        critid = getattr(myitems,'crit__modified_ATSortCriterion')
    except AttributeError:
        critid = myitems.addCriterion(field='modified',criterion_type='ATSortCriterion')
    if critid <> None:
        sortcrit = critid
        sortcrit.reversed = True
    else:
        print >> out, "Could not create sort criteria, critid = %s" % (critid,)
        
    print >> out, "Added My Recent Items SmartFolder to Main Dashboard Collage."
    manager = IDynamicViewManager(myitems)
    manager.setLayout("portlet")
    print >> out, "Set the My Recent Items SmartFolder to Portlet View."
    return out.getvalue()

def setupHomeCollages(portal):
    out = StringIO()
    print >> out, setup_recentpictures(portal)
    print >> out, setup_recentblogs(portal)
    print >> out, setup_recentupdates(portal)
    print >> out, setup_myreviewlist(portal)
    print >> out, setup_myrecentitems(portal)
    print >> out, setup_defaultview(portal)
    return out.getvalue()

def getOrCreateType(portal, atobj, newid, newtypeid):
    """
    Gets the object specified by newid if it already exists under
    atobj or creates it there with the id given in newtypeid
    """
    #import pdb;pdb.set_trace()
    try:
        newobj = getattr(atobj,newid) #get it if it already exists
    except AttributeError:  #newobj doesn't already exist
        try:            
            _ = atobj.invokeFactory(id=newid,type_name=newtypeid)            
        except ValueError:
            _createObjectByType(newtypeid, atobj, newid)
        except Unauthorized:
            _createObjectByType(newtypeid, atobj, newid)
        newobj = getattr(atobj,newid)
        notify(ObjectCreatedEvent(newobj))
    return newobj

def getSpaces(portal):
    return getOrCreateType(portal,portal,"spaces","SpacesFolder")

def getSpaceDashboard(portal):
    spaces = getSpaces(portal)
    dash =  getOrCreateType(portal,spaces,"spaces-dashboard","Collage")
    return dash


def setup_recentspaces(portal):
    out = StringIO()
    coll = getSpaceDashboard(portal)
    row = getOrCreateType(portal,coll,"row1","CollageRow")
    col = getOrCreateType(portal,row,"col1","CollageColumn")
    spaces = getOrCreateType(portal,col,"recently-created-spaces","Topic")
    spaces.title = 'Recently Created Spaces'
    spaces.description = 'The most recently created Spaces on this Ubify Site'
    spaces.limitNumber = True;
    spaces.itemCount = 10;

    try:
        critid = getattr(spaces,'crit__Type_ATPortalTypeCriterion')
    except AttributeError:
        critid = spaces.addCriterion(field='Type',criterion_type='ATPortalTypeCriterion')
    if critid <> None:
        typecrit = critid
        typecrit.value = (u'Space',)
    else:
        print >> out, "Could not create type criteria, critid = %s" % (critid,)
        #import pdb; pdb.set_trace()

    try:
        critid = getattr(spaces,'crit__modified_ATSortCriterion')
    except AttributeError:
        critid = spaces.addCriterion(field='modified',criterion_type='ATSortCriterion')
    if critid <> None:
        sortcrit = critid
        sortcrit.reversed = True
    else:
        print >> out, "Could not create sort criteria, critid = %s" % (critid,)
        #import pdb; pdb.set_trace()

    print >> out, "Added Recent Spaces SmartFolder to Spaces Dashboard Collage."
    manager = IDynamicViewManager(spaces)
    manager.setLayout("portlet")
    print >> out, "Set the Recent Spaces SmartFolder to Portlet View."
    return out.getvalue()

def setup_myspaces(portal):
    out = StringIO()
    out = StringIO()
    coll = getSpaceDashboard(portal)
    row = getOrCreateType(portal,coll,"row2","CollageRow")
    col = getOrCreateType(portal,row,"col1","CollageColumn")
    spaces = getOrCreateType(portal,col,"my-spaces","Topic")


    spaces.title = 'My Spaces'
    spaces.description = 'The most recently created Spaces on this Ubify Site'
    spaces.limitNumber = True;
    spaces.itemCount = 10;

    try:
        critid = getattr(spaces,'crit__Type_ATPortalTypeCriterion')
    except AttributeError:
        critid = spaces.addCriterion(field='Type',criterion_type='ATPortalTypeCriterion')
    if critid <> None:
        typecrit = critid
        typecrit.value = (u'Space',)
    else:
        print >> out, "Could not create type criteria, critid = %s" % (critid,)
        #import pdb; pdb.set_trace()
    
    try:
        critid = getattr(spaces,'crit__Creator_ATCurrentAuthorCriterion')
    except AttributeError:
        critid = spaces.addCriterion(field='Creator', criterion_type='ATCurrentAuthorCriterion')
    if critid <> None:
        creatorcrit = critid
    else:
        print >> out, "Could not create creator criteria, critid = %s" % (critid,)
        
    try:
        critid = getattr(spaces,'crit__modified_ATSortCriterion')
    except AttributeError:
        critid = spaces.addCriterion(field='modified',criterion_type='ATSortCriterion')
    if critid <> None:
        sortcrit = critid
        sortcrit.reversed = True
    else:
        print >> out, "Could not create sort criteria, critid = %s" % (critid,)
        #import pdb; pdb.set_trace()

    print >> out, "Added My Spaces SmartFolder to Spaces Dashboard Collage."
    manager = IDynamicViewManager(spaces)
    manager.setLayout("portlet")
    print >> out, "Set the My Spaces SmartFolder to Portlet View."
    return out.getvalue()

def setup_recentspaceitems(portal):
    out = StringIO()
    
    out = StringIO()
    coll = getSpaceDashboard(portal)
    row = getOrCreateType(portal,coll,"row2","CollageRow")
    col = getOrCreateType(portal,row,"col2","CollageColumn")
    spaces = getOrCreateType(portal,col,"recent-items-in-spaces","Topic")

    spaces.title = 'Recent items in Spaces'
    spaces.description = 'The most recently created items inside Spaces on this Ubify Site'
    spaces.limitNumber = True;
    spaces.itemCount = 10;

    try:
        critid = getattr(spaces,'crit__Type_ATPortalTypeCriterion')
    except AttributeError:
        critid = spaces.addCriterion(field='Type',criterion_type='ATPortalTypeCriterion')
    if critid <> None:
        typecrit = critid
        typecrit.value = (u'File',u'Link',u'Document','Image','Event',)
    else:
        print >> out, "Could not create type criteria, critid = %s" % (critid,)
        #import pdb; pdb.set_trace()

    try:
        critid = getattr(spaces,'crit__modified_ATSortCriterion')
    except AttributeError:
        critid = spaces.addCriterion(field='modified',criterion_type='ATSortCriterion')
    if critid <> None:
        sortcrit = critid
        sortcrit.reversed = True
    else:
        print >> out, "Could not create sort criteria, critid = %s" % (critid,)
        #import pdb; pdb.set_trace()

    print >> out, "Added Recent Items in Spaces SmartFolder to Spaces Dashboard Collage."
    manager = IDynamicViewManager(spaces)
    manager.setLayout("portlet")
    print >> out, "Set the Recent Items in Spaces SmartFolder to Portlet View."
    return out.getvalue()

def setup_spacedefaultview(portal):
    out = StringIO()
    spaces = getSpaces(portal)
    spaces.default_page = 'spaces-dashboard'
    print >> out, "Set spaces default page to Spaces Dashboard Collage."
    return out.getvalue()

def setupSpaceCollages(portal):
    out = StringIO()
    print >> out, setup_recentspaces(portal)
    print >> out, setup_myspaces(portal)
    print >> out, setup_recentspaceitems(portal)
    print >> out, setup_spacedefaultview(portal)
    return out.getvalue()

def remove_calendar(portal):
    out = StringIO()
    rightColumn = getUtility(IPortletManager, name=u'plone.rightcolumn', context=portal)
    right = getMultiAdapter((portal, rightColumn,), IPortletAssignmentMapping, context=portal)
    try:
        del right[u'calendar']
        print >> out, "Deleted calendar portlet from Main dashboard."
    except KeyError:
        print >> out, "Hmmm.... strange, the calendar portlet was not found. Continuing..."
    return out.getvalue()

def enable_wikitype(portal):
    out = StringIO()
    mcpa = MarkupControlPanelAdapter(portal)
    mcpa.set_wiki_enabled_types(('Page',))	
    print >> out, "Set default wiki behavior for following content types"
    print >> out, mcpa.get_wiki_enabled_types()
    return out.getvalue()

def configureSiteTitle(portal):
    out = StringIO()
    if portal.title.lower() == "site":
        portal.title = "cyn.in site"
        portal.description = "Instant Collaboration"
        print >> out, "Configured Site Title and Description."
    else:
        print >> out, "Site title has already been changed, so NOT changing site title or description."
    return out.getvalue()

def addGroups(context):
    out = StringIO()
    portalgroups = getToolByName(context.getSite(), "portal_groups")
    if portalgroups is not None:
        
        currgroups = portalgroups.listGroups()
        for groupname in newgroups:
            if [g for g in currgroups if g.id == groupname] == []:
                portalgroups.addGroup(groupname,(),() )
                if groupname == siteadmingroup:
                    sag = portalgroups.getGroupById(siteadmingroup)
                    sagroles = sag.getRoles()
                    if "Manager" not in sagroles:
                        sagroles.append("Manager")
                        portalgroups.editGroup(siteadmingroup,sagroles, groups=())
                        sagdebug = portalgroups.getGroupById(siteadmingroup)
                        print >> out, "SiteAdmin Roles: %s" % sagdebug.getRoles()
                print >> out, "Created new group: %s" % groupname
        
        #Create internal group
        if "internal" not in currgroups: #check if internal group exists
            portalgroups.addGroup("internal",(),() ) #add if it doesn't exist
        sag = portalgroups.getGroupById("internal") #get the group object
        for groupname in newgroups: 
            if "%suser" % groupname not in sag.getGroups():  #if any of our new groups is not already there in internal's groups
                portalgroups.addPrincipalToGroup("%suser" % groupname,sag.id)  #add it

    else:
        print >> out, "Could not get group administration tool, something is DRASTICALLY wrong, giving up trying to add groups."
    return out.getvalue()

def setSpacesWorkflowPolicy(sattr,inpolicy=SPACE_PLACEFUL_WORKFLOW_POLICY,belowpolicy=PLACEFUL_WORKFLOW_POLICY):
    out = StringIO()    
    placeful_workflow = getToolByName(sattr, 'portal_placeful_workflow')
    try:
        config = placeful_workflow.getWorkflowPolicyConfig(sattr)
    except AttributeError:
        sattr.manage_addProduct['CMFPlacefulWorkflow'].manage_addWorkflowPolicyConfig()
        config = placeful_workflow.getWorkflowPolicyConfig(sattr)

    if config is None:
        sattr.manage_addProduct['CMFPlacefulWorkflow'].manage_addWorkflowPolicyConfig()
        config = placeful_workflow.getWorkflowPolicyConfig(sattr)
        config.setPolicyIn(policy=inpolicy)
        config.setPolicyBelow(policy=belowpolicy)
        print >> out, "set Space: %s workflow policy to %s", (sattr.title, inpolicy)
        print >> out, "Set Space: %s BELOW workflow policy to %s" % (sattr.title, belowpolicy)
        return out.getvalue()

    if config.getPolicyIn() == None:
        config.setPolicyIn(policy=inpolicy)
        print >> out, "Set Space: %s workflow policy to %s" % (sattr.title, inpolicy)
    elif config.getPolicyIn() <> None: ### XXX: Not checking current workflow policy to enable hard coded workflow (DKG)
        config.setPolicyIn(policy=inpolicy)
        print >> out, "Set Space: %s workflow policy to %s" % (sattr.title, inpolicy)

    if config.getPolicyBelow() == None:
        config.setPolicyBelow(policy=belowpolicy)
        print >> out, "Set Space: %s BELOW workflow policy to %s" % (sattr.title, belowpolicy)
    elif config.getPolicyBelow() <> None : ###and config.getPolicyBelow().workflow_policy != PLACEFUL_WORKFLOW_POLICY  ##XXX: Force setting the below workflow even if it is set so that all spaces follow the default content workflow, at least on site policy install (DKG)
        config.setPolicyBelow(policy=belowpolicy)
        print >> out, "Set Space: %s BELOW workflow policy to %s" % (sattr.title, belowpolicy)

    return out.getvalue()

def setSpaceGroupUsers(portal):
    """Iterates through our groups and assigns them local roles in each space
    Steps:
    1. Get spaces folder
    2. Iterate through new groups list
    3. Get space for group name
    4. Call setSpaceUsers with space and group name
    """
    
    spaces = getSpaces(portal)
    
    if createtestspaces:
        for group in newgroups:
            thespace = getattr(spaces,group)
            setSpaceUsers(portal,thespace,group)
    
    if approval_space['createspace']:
        setApprovalGroups(portal)
    setSpacesFolderUsers(portal)
    
def setSpacesFolderUsers(portal):
    """Iterates through the new groups list and assigns them as contributor on the /spaces Spaces folder
    Giving contributor access to the Spaces folder is the only way we have of listing Spaces.
    We turn off acquire (inherit sharing settings) in Save Space handler (handlers.py) to accomodate this.
    """
    spaces = getSpaces(portal)
    member_access = ('Contributor',)#space member access:
    for group in newgroups:
        spaces.manage_setLocalRoles(group, list(member_access))    
    spaces.reindexObjectSecurity()

def setApprovalGroups(portal):
    spaces = getSpaces(portal)
    approvalspace = getattr(spaces,approval_space['id'])
    viewer_access = ('Reader',) #space viewer access:    
    member_access = ('Contributor',)#space member access:
    reviewer_access = ('Reviewer',)#space reviewer access:
    manager_access = ('Editor',)#space manager access:

    for vwrs in approval_space["Viewers"]:
        approvalspace.manage_setLocalRoles(vwrs,list(viewer_access))
    
    for cont in approval_space["Contributors"]:
        approvalspace.manage_setLocalRoles(cont,list(member_access))
        
    for rvws in approval_space["Reviewers"]:
        approvalspace.manage_setLocalRoles(rvws,list(reviewer_access))
        
    for edts in approval_space["Editors"]:
        approvalspace.manage_setLocalRoles(edts,list(manager_access))

def setSpaceUsers(portal, space,groupname):
    """ Sets the users of the space as per our strategy
    Steps:
    1. Get existing user role settings for the space
    2. If the space is new, there will be no userrole settings for the space, so we can proceed to add
    3. If there are already existing settings, then we have to only add the userrole settings that are there, and not remove any
    
    """
    #Step 1: Get existing roles
    #XXX: Ignored for now, will patch up to check current users later. (DKG)
    acl = getattr(portal,'acl_users')
    
    local_roles = acl._getLocalRolesForDisplay(space)
    #local roles list format: name, roles, rtype, rid in local_roles
    
    ##Step 3: Set roles as per schema:
    #1. user 1,2,3 will be only viewers
    #2. user 4,5,6 will be space members
    #3. user 7,8,9 will be space managers
    #4. user 10 will have no access on the space
    
    #space viewer access:
    viewer_access = ('Reader',)
    
    #space member access:
    member_access = ('Contributor',)
    
    #space manager access:
    manager_access = ('Contributor','Editor')
    
    userlist = []
    for i in range(1,11):
        userlist.append("%s%s" % (groupname.lower(),i))
        
    space.manage_setLocalRoles(userlist[0], list(viewer_access))    
    space.manage_setLocalRoles(userlist[1], list(viewer_access))    
    space.manage_setLocalRoles(userlist[2], list(viewer_access))    
    space.manage_setLocalRoles(userlist[3], list(member_access))    
    space.manage_setLocalRoles(userlist[4], list(member_access))    
    space.manage_setLocalRoles(userlist[5], list(member_access))    
    space.manage_setLocalRoles(userlist[6], list(manager_access))    
    space.manage_setLocalRoles(userlist[7], list(manager_access))    
    space.manage_setLocalRoles(userlist[8], list(manager_access))    
    #context.manage_setLocalRoles(userlist[9], list(new_roles))    <-- 10th user has no access
    
    
    

def addSpaces(portal):
    out = StringIO()
    spaces = getSpaces(portal)
    
    if createtestspaces:        
        for s in newgroups:
            try:
                sattr = getattr(spaces,s)
            except AttributeError:
                sattr = getOrCreateType(portal,spaces,s,"Space")
                sattr.title = "%s %s" % (s,"Space")
                sattr.description = "A Space for people in the %s group" % s
                sattr.reindexObject()
                notify(ObjectCreatedEvent(sattr))
                print >> out, "Created new Space: %s" % sattr.title
            print >> out, setSpacesWorkflowPolicy(sattr)
    
    # Add Reviewed content space
    if approval_space['createspace']:
        try:
            sattr = getattr(spaces,approval_space['id'])
            print >> out, setSpacesWorkflowPolicy(sattr,belowpolicy=REVIEW_PLACEFUL_WORKFLOW_POLICY)
        except AttributeError:
            sattr = getOrCreateType(portal,spaces,approval_space['id'],"Space")
            sattr.title = approval_space['title']
            sattr.description = approval_space['description']
            sattr.reindexObject()
            notify(ObjectCreatedEvent(sattr))
            print >> out, "Created new Space: %s" % sattr.title
        print >> out, setSpacesWorkflowPolicy(sattr,belowpolicy=REVIEW_PLACEFUL_WORKFLOW_POLICY)
    
    return out.getvalue()

def addUsers(context):
    out = StringIO()
    membership = getToolByName(context.getSite(), 'portal_membership')
    portalgroups = getToolByName(context.getSite(), "portal_groups")
    membership.addMember(siteadmin, siteadminpass, ('Member','Authenticated',), ())
    portalgroups.addPrincipalToGroup(siteadmin,siteadmingroup)
    
    print >> out, "Created SiteAdmin=> Login: %s, Password: %s" % (siteadmin, siteadminpass)
    #Add test users, comment below lines for production
    #import pdb;pdb.set_trace()
    if createtestusers:
        for ngname in newgroups:
            for i in range(1,11):                
                username = '%s%s' % (ngname.lower(),i)
                membership.addMember(username, testuserpass, ("Authenticated","Member",), ())
                portalgroups.addPrincipalToGroup(username,ngname)
                print >> out, "Created Test User=> Login: %s, Password: %s, Group: %s" % (username,testuserpass,ngname)
    return out.getvalue()

def setupSiteTabs(context):
    out = StringIO()
    portal = context.getSite()
    
    portal_actions = getToolByName(portal,'portal_actions')
    
    #import pdb; pdb.set_trace()
    # Add default tabs
    allportalactionids = [act.id for act in portal_actions.listActions()] #Make a list of all portal action ids (dkg)
    ouractionids = [act["id"] for act in sitetabs] #Get our ids from the sitetabs list (dkg)
    newactionids = [newid for newid in ouractionids if newid not in allportalactionids] #Get list of ids that are not already existing as portal_actions (dkg)
    newactions = [stab for stab in sitetabs if stab["id"] in newactionids]  #Make list of new actions that we'll be adding
    
    for st in newactions: #Filter list to only have those site tabs that are not already added (DKG)
        ac = Action(id=st["id"],title=st["name"],url_expr=st["url_expr"],available_expr='python:(member is not None)',permissions=('View',),visible=st["visible"])
        portal_actions.portal_tabs._setObject(st["id"],ac)
        print >> out, "Created new site tab: %s" % st["id"]
    
    # Disable an option that generates tabs for all items created at the root level.
    portal_properties=getToolByName(portal, 'portal_properties')
    
    portal_properties.site_properties.manage_changeProperties(disable_folder_sections=True)
    print >> out, "Disabling an option that generates tabs for all items created at the root level."
    print >> out, portal_properties.site_properties.disable_folder_sections

    print >> out, "Done with setupSiteTabs"
    return out.getvalue()

def configureCMFNotification(portal):
    out = StringIO()
    
    ntool = getToolByName(portal, NTOOL_ID)
    changeProperty = lambda key, value: \
            ntool.manage_changeProperties(**{key: value})
    #enable notification on Item creation
    
    changeProperty('item_creation_notification_enabled', True)
    changeProperty('on_item_creation_users', ['* :: *'])
    changeProperty('on_item_creation_mail_template',['* :: string:creation_mail_notification'])
    
    print >> out, "On Item Creation Notification has been enabled."
    
    #enable notification on Item modification
    changeProperty('item_modification_notification_enabled', True)
    changeProperty('on_item_modification_users', ['* :: *'])
    changeProperty('on_item_modification_mail_template',['* :: string:modification_mail_notification'])
        
    print >> out, "On Item Modification Notification has been enabled."
    
    #enable notification on Work Flow Transition
    changeProperty('wf_transition_notification_enabled', True)
    changeProperty('on_wf_transition_users',['* :: *'])
    changeProperty('on_wf_transition_mail_template',['* :: string:workflow_mail_notification'])
    
    print >> out, "On Workflow transition Notification has been enabled."
    
    #enable notification on Discussion Item Creation
    #changeProperty('discussion_item_creation_notification_enabled',True)
    #changeProperty('on_discussion_item_creation_users',['* :: *'])
    #changeProperty('on_discussion_item_creation_mail_template',['* :: string:discussion_mail_notification'])
    
    #print >> out, "On Discussion Item Creation Notification has been enabled."
    
    return out.getvalue()

def configureMailHost(portal):
    out = StringIO()
    mailHost = getattr(portal,'MailHost')

    if mailhostconfiguration["configure"]:
        print >> out, "Starting Mail Configuration changes"
        if mailHost.smtp_host == '':
            mailHost.smtp_host = mailhostconfiguration["smtphost"]
            print >> out, mailHost.smtp_host
        if mailHost.smtp_port == None:
            mailHost.smtp_port = mailhostconfiguration["smtpport"]
            print >> out, mailHost.smtp_port
        if portal.email_from_name == '':
            portal.email_from_name = mailhostconfiguration["fromemailname"]
            print >> out, portal.email_from_name
        if portal.email_from_address == '':
            portal.email_from_address = mailhostconfiguration["fromemailaddress"]
            print >> out, portal.email_from_address
        print >> out, "Done with Mail Configuration"
        
    return out.getvalue()

def disableMailHost(portal,out):    
    mailHost = getattr(portal,'MailHost')
    
    smtphost = ""
    if mailHost <> None:
        smtphost = mailHost.smtp_host
        mailHost.smtp_host = ""
        print >> out, "Disabling configured smtp host before reinstalling : %s" % (smtphost,)
    return smtphost

def enableMailHost(portal,out,smtphost):
    mailHost = getattr(portal,'MailHost')
    
    if mailHost <> None and smtphost != "":
        mailHost.smtp_host = smtphost
        print >> out, "Enabling configured smtp host after reinstallation: %s" % (smtphost,)
    

def addRolesToListOfAllowedRolesToAddKeywords(portal):
    out = StringIO()
    portal_properties=getToolByName(portal, 'portal_properties')
    site_prop = portal_properties.site_properties
    for r in ALLOWEDROLESTOADDKEYWORDS:
        if r not in site_prop.allowRolesToAddKeywords:
            site_prop._updateProperty('allowRolesToAddKeywords', site_prop.allowRolesToAddKeywords + (r,))
            print >> out, "Added role %s to allow list of roles for adding keywords" % (r,)
    return out.getvalue()

def modifyKupuResourceTypes(portal):
    out = StringIO()
    
    kupu_library_tool = getattr(portal,'kupu_library_tool')
    type_map = kupu_library_tool.__of__(portal)
    
    collection_portal_types = type_map.getPortalTypesForResourceType("collection")
    new_portal_types = ('Plone Site','Large Plone Folder',) + spacesdefaultaddabletypes
    type_info = [
        dict(resource_type='collection',
            portal_types=new_portal_types),
    ]
    type_map.updateResourceTypes(type_info)
    
    print >> out, "Modified collection resourcetype of kupu with these portal types: %s" % (new_portal_types,)
    return out.getvalue()

def configureKupuToolbar(portal):
    out = StringIO()
    
    kltool = getattr(portal,'kupu_library_tool')
    filteroptions = kltool.getFilterOptions()
    for filteroption in filteroptions:
        if filteroption["id"] in kuputoolbaroptions:    
            filteroption["visible"] = True
    
    kltool.set_toolbar_filters(filteroptions,kltool._global_toolbar_filter)
    
    print >> out, "Configured kupu toolbar for these options available %s" % (kuputoolbaroptions,)
    
    if kltool.linkbyuid == False:
        kltool.linkbyuid = True
        print >> out, "Configured kupu insert image option to link by uid"
    
    return out.getvalue()

def removeAnonymousAccessOnMembers(portal):
    out = StringIO()    
    try:       
       members = getattr(portal,"Members")
       found = 0
       perms = members.rolesOfPermission('View')
       for perm in perms:
            if perm['name'] == 'Anonymous' and perm['selected'] == 'SELECTED':
                found = 1
            if found == 1:
                break;
                
       if found == 1:
            members.content_status_modify(workflow_action='retract')
            members.content_status_modify(workflow_action='publish')
            print >> out, "Modified members access security"
    except AttributeError:
        pass
    
    return out.getvalue()

def migration_steps(portal):
    out = StringIO()    
    portal_catalog = getattr(portal,'portal_catalog')
    dashboards = [b.getObject() for b in portal_catalog(portal_type='Collage')]
    ids = ""
    for obj in dashboards:
        ids = ids + obj.id + ", "
        parent = obj.getParentNode()
        parent.manage_delObjects(ids=[obj.id])
        transaction.savepoint()
    print >> out, "Dashboards deleted : %s" % (ids,)
    
    objects_visible_state = [newObj.getObject() for newObj in portal_catalog(review_state='visible')]    
    for iobj in objects_visible_state:
        iobj.content_status_modify(workflow_action='publish')
        print >> out, "Modified state from visible to publish for %s" % (iobj,)
         
    pcontrolpanel = getattr(portal,'portal_controlpanel')
    if pcontrolpanel <> None:
        for action in pcontrolpanel.listActions():
            if action.id.lower() == 'portalskin':
                action.visible = False
            if action.id.lower() == 'zmi':
                action.visible = False
    return out.getvalue()

def getViews(portal):
    return getOrCreateType(portal,portal,"views","SmartviewFolder")

def addDefaultViewsForPloneSite(portal):
    out = StringIO()
    portal_types = portal.portal_types
    plonesite = getattr(portal_types,'Plone Site')
    found = False
    for vm in plonesite.view_methods:
        if vm == 'site_home':
            found = True
        if found:
            break;
    
    if found == False:
        plonesite._updateProperty('view_methods',('site_home',))
    if found == True:
        plonesite._updateProperty('view_methods',('site_home',))
    if plonesite.default_view != 'site_home':
        plonesite._updateProperty('default_view','site_home')
    if plonesite.getLayout() != 'site_home':
        plonesite.setLayout('site_home')
        print >> out, "Configured %s as default page for site." % ('site_home',)
    
    return out.getvalue()

def renameDefaultEntries(portal):
    out = StringIO()    
    items=[]
    for s in defaulttitles:
        obj = None
        try:
            obj = getattr(portal,s["id"])
        except AttributeError:
            pass
        if obj <> None and obj.portal_type == s["type"] and obj.title == "":
            obj.title = s["title"]
            obj.description = s["description"]
            obj.reindexObject()
            print >> out, "Renamed object : %s" % (obj,)
    return out.getvalue()

def addDefaultCategories(portal):
    out = StringIO()
    
    pm = portal.portal_metadata
    objdcmi = pm.DCMI
    if objdcmi <> None:
        objdcmi.updateElementPolicy("Subject","<default>",0,0,"",0,default_categories)
        print >> out, "Updated default subjects as %s" % (default_categories,)
    return out.getvalue()

def configureKupuStyles(portal):
    out = StringIO()
    kupu_library_tool = getattr(portal,'kupu_library_tool')
    kupu_library_tool.configure_kupu(parastyles=kupu_paragraph_styles)
    print >> out, "Paragraph styles are configured with new styles : %s" % (kupu_paragraph_styles,)
    return out.getvalue()

def add_placeful_workflow_policy_for_name(portal,name,title):
    out = StringIO()
    placeful_workflow = getToolByName(portal, 'portal_placeful_workflow', None)
    workflowtypes = spacecontentworkflowtypes
    if placeful_workflow is None:
        print >> out, "Cannot install placeful workflow policy - CMFPlacefulWorkflow not available"
    elif name not in placeful_workflow.objectIds():
        placeful_workflow.manage_addWorkflowPolicy(name, 
                                                   duplicate_id='portal_workflow')
        policy = placeful_workflow.getWorkflowPolicyById(name)
        policy.setTitle(title)
        policy.setDefaultChain((name,))
        if name == 'ubify_user_spaces_folder_workflow':
            workflowtypes = workflowtypes + ('SpacesFolder',)
        policy.setChainForPortalTypes((workflowtypes), name)
        print >> out, "Installed workflow policy %s" % name
    else:
        print >> out, "Workflow policy %s already installed" % name
        
    return out.getvalue()

def add_placeful_workflow_policy(portal):
    """Add the placeful workflow policy used by Spaces.
    """
    out = StringIO()    
    placeful_workflow = getToolByName(portal, 'portal_placeful_workflow', None)
    
    print >> out, add_placeful_workflow_policy_for_name(portal,MEMBERS_PLACEFUL_WORKFLOW_POLICY,'Publish or Keep Private Workflow')
    print >> out, add_placeful_workflow_policy_for_name(portal,MEMBERS_PLACEFUL_WORKFLOW_POLICY_BELOW,'Private or Keep Publish Workflow')
    print >> out, add_placeful_workflow_policy_for_name(portal,USER_SPACEFOLDER_WORKFLOW_POLICY,'My Space Workflow')
    print >> out, add_placeful_workflow_policy_for_name(portal,USER_PRIVATE_SPACE_POLICY,'User Private Space Workflow')
    print >> out, add_placeful_workflow_policy_for_name(portal,USER_PUBLIC_SPACE_POLICY,'User Public Space Workflow')
    print >> out, add_placeful_workflow_policy_for_name(portal,USER_PUBLIC_SPACE_BELOW_POLICY,'Public Space Content Workflow')
    return out.getvalue()



def importVarious(context):
    """Miscellanous steps import handle
    """
    
    # Ordinarily, GenericSetup handlers check for the existence of XML files.
    # Here, we are not parsing an XML file, but we use this text file as a 
    # flag to check that we actually meant for this import step to be run.
    # The file is found in profiles/default.

    #import pdb; pdb.set_trace()
    if context.readDataFile('ubify.policy_various.txt') is None:
        return

    out = StringIO()
    portal = context.getSite()

    logger = context.getLogger("ubify.policy")

    old_smtphost = disableMailHost(portal,out)#<-- Do this first so that reinstallation will not fire any notifications if any
    logger.info(configureSiteTitle(portal))
    logger.info(configureContentTypes(portal))
    logger.info(setup_folders(portal))
    logger.info(setVersionedTypes(portal))
    logger.info(remove_calendar(portal))
    logger.info(enable_wikitype(portal))
    logger.info(setupSiteTabs(context))
    logger.info(addGroups(context))
    logger.info(addUsers(context))
    logger.info(addSpaces(portal))    
    
    logger.info(configureCMFNotification(portal))
    logger.info(addRolesToListOfAllowedRolesToAddKeywords(portal))
    logger.info(modifyKupuResourceTypes(portal))
    logger.info(configureKupuToolbar(portal))
    logger.info(configureKupuStyles(portal))
    logger.info(disableGlobalAdds(portal)) #<-- Do this last, so that we can add programatically
    logger.info(setSpaceGroupUsers(portal))
    
    logger.info(add_placeful_workflow_policy(portal))    
    logger.info(removeAnonymousAccessOnMembers(portal))
    logger.info(getViews(portal))
    
    
    logger.info(addDefaultViewsForPloneSite(portal))
    logger.info(renameDefaultEntries(portal))
    
    logger.info(addDefaultCategories(portal))    
    logger.info(migration_steps(portal))
   
    logger.info(updateWorkflowSecurity(portal))
    logger.info(startMigration(context))       #<-- Migration step need to be last step before enabling MailHost
    logger.info(updateWorkflowSecurity(portal))
    logger.info(configureMailHost(portal))
    logger.info(enableMailHost(portal,out,old_smtphost)) #<-- Do this last so that mail smtp host configured before reinstallation will be maintained.
