from Products.Five.browser.pagetemplatefile import ViewPageTemplateFile
from plone.app.layout.viewlets.common import ViewletBase

# Sample code for a basic viewlet (In order to use it, you'll have to):
# - Un-comment the following useable piece of code (viewlet python class).
# - Rename the vielwet template file ('browser/viewlet.pt') and edit the
#   following python code accordingly.
# - Edit the class and template to make them suit your needs.
# - Make sure your viewlet is correctly registered in 'browser/configure.zcml'.
# - If you need it to appear in a specific order inside its viewlet manager,
#   edit 'profiles/default/viewlets.xml' accordingly.
# - Restart Zope.
# - If you edited any file in 'profiles/default/', reinstall your package.
# - Once you're happy with your viewlet implementation, remove any related
#   (unwanted) inline documentation  ;-p

#class MyViewlet(ViewletBase):
#    render = ViewPageTemplateFile('viewlet.pt')
#
#    def update(self):
#        self.computed_value = 'any output'

from zope.component import getMultiAdapter
from AccessControl import getSecurityManager
from Products.CMFCore.utils import getToolByName
from plone.app.layout.globals.interfaces import IViewView 
from zope.interface import implements, alsoProvides
from urllib import quote_plus


class SiteActionsViewlet(ViewletBase):

    def update(self):
        context_state = getMultiAdapter((self.context, self.request),name=u'plone_context_state')
        self.site_actions = context_state.actions().get('site_actions', None)
    render = ViewPageTemplateFile('templates/site_actions.pt')

class FaviconViewlet(ViewletBase):
    render = ViewPageTemplateFile('templates/favicon.pt')

class PersonalBarViewlet(ViewletBase):
    render = ViewPageTemplateFile('templates/personal_bar.pt')

    def update(self):
        portal_state = getMultiAdapter((self.context, self.request),
                                            name=u'plone_portal_state')
        context_state = getMultiAdapter((self.context, self.request),
                                        name=u'plone_context_state')
        tools = getMultiAdapter((self.context, self.request), name=u'plone_tools')
        
        sm = getSecurityManager()

        self.cportal_url = portal_state.portal_url()

        self.user_actions = context_state.actions().get('user', None)
        plone_utils = getToolByName(self.context, 'plone_utils')
        self.getIconFor = plone_utils.getIconFor

        self.anonymous = portal_state.anonymous()

        if not self.anonymous:
        
            member = portal_state.member()
            userid = member.getId()
            
            if sm.checkPermission('Portlets: Manage own portlets', self.context):
                self.homelink_url = self.cportal_url + '/dashboard'
            else:
                self.homelink_url = self.cportal_url + '/author/' + quote_plus(userid)
            
            member_info = tools.membership().getMemberInfo(member.getId())
            fullname = member_info.get('fullname', '')
            if fullname:
                self.user_name = fullname
            else:
                self.user_name = userid

class ContentActionsViewlet(ViewletBase):
    render = ViewPageTemplateFile('templates/contentactions.pt')
    
    def update(self):
        context_state = getMultiAdapter((self.context, self.request),
                                            name=u'plone_context_state')

        self.object_actions = context_state.actions().get('object_actions', [])
        self.portal_actionicons = getToolByName(self.context, 'portal_actionicons')
        
        #import pdb; pdb.set_trace()
        
        # The drop-down menus are pulled in via a simple content provider
        # from plone.app.contentmenu. This behaves differently depending on
        # whether the view is marked with IViewView. If our parent view 
        # provides that marker, we should do it here as well.
        if IViewView.providedBy(self.__parent__):
            alsoProvides(self, IViewView)
        
    def icon(self, action):
        return self.portal_actionicons.renderActionIcon('content_actions', action['id'], None)
