###############################################################################
#cyn.in is an open source Collaborative Knowledge Management Appliance that 
#enables teams to seamlessly work together on files, documents and content in 
#a secure central environment.
#
#cyn.in v2 an open source appliance is distributed under the GPL v3 license 
#along with commercial support options.
#
#cyn.in is a Cynapse Invention.
#
#Copyright (C) 2008 Cynapse India Pvt. Ltd.
#
#This program is free software: you can redistribute it and/or modify it under
#the terms of the GNU General Public License as published by the Free Software 
#Foundation, either version 3 of the License, or any later version and observe 
#the Additional Terms applicable to this program and must display appropriate 
#legal notices. In accordance with Section 7(b) of the GNU General Public 
#License version 3, these Appropriate Legal Notices must retain the display of 
#the "Powered by cyn.in" AND "A Cynapse Invention" logos. You should have 
#received a copy of the detailed Additional Terms License with this program.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of 
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
#Public License for more details.
#
#You should have received a copy of the GNU General Public License along with 
#this program.  If not, see <http://www.gnu.org/licenses/>.
#
#You can contact Cynapse at support@cynapse.com with any problems with cyn.in. 
#For any queries regarding the licensing, please send your mails to 
# legal@cynapse.com
#
#You can also contact Cynapse at:
#802, Building No. 1,
#Dheeraj Sagar, Malad(W)
#Mumbai-400064, India
###############################################################################
from Products.Five.browser.pagetemplatefile import ViewPageTemplateFile
from plone.app.layout.viewlets.common import ViewletBase
from zope.component import getMultiAdapter
from Products.CMFCore.utils import getToolByName

from zope.component import getUtility,getAdapters
from zope.app.publisher.interfaces.browser import IBrowserMenu

class AddNewMenuViewlet(ViewletBase):
    render = ViewPageTemplateFile('templates/addnew_menu.pt')
    
    def getMenuItemsForSiteHome(self,portal,menu):
        #import pdb;pdb.set_trace()
        objSpaces = getattr(portal,'spaces')
        objViews = getattr(portal,'views')
        addnewitems = []        
        spacesmenu = menu.getMenuItems(objSpaces,self.request)
        viewsmenu = menu.getMenuItems(objViews,self.request)
        for ob in spacesmenu:
            if ob['extra']['id'] <> '_settings':
                addnewitems.append(ob)
        for ob1 in viewsmenu:
            if ob1['extra']['id'] <> '_settings':
                addnewitems.append(ob1)
        return addnewitems
    
    def update(self):
        menu = getUtility(IBrowserMenu, name='plone_contentmenu_factory')
        
        portal_state = getMultiAdapter((self.context, self.request),name=u'plone_portal_state')
        context_state = getMultiAdapter((self.context, self.request),name=u'plone_context_state')
        
        typetool= getToolByName(self.context, 'portal_types')
        
        object_typename = self.context.portal_type
        fti = getattr(typetool,'Plone Site')
        self.showsitehomemenu = False
        if fti.portal_type == object_typename:
            self.render = ViewPageTemplateFile('templates/sitehomeaddnew_menu.pt')
            self.addnewitems = self.getMenuItemsForSiteHome(portal_state.portal(),menu)
            if portal_state.portal_url() == context_state.current_base_url().rstrip("/"):
                self.showsitehomemenu = True
        else:
            self.addnewitems = menu.getMenuItems(self.context, self.request)

    def icon(self, action):
        icon = action.get('icon', None)
        if icon is None:
            icon = self.getIconFor('content_actions', action['id'])
        return icon
    
    